<template>
  <!--
    Default input container is a label tag,
    to ignore usage of "for" attribute, related to an input "id"
  -->
  <label
    :data-checked="checked"
    :class="getElementCssClass('wrapper')"
  >

    <!--
      Hidden basic HTML input "radio" type
      Radio render can be overriden with slot, see below
    -->
    <input
      v-model="vModel"
      type="radio"
      :name="name"
      :value="value"
      class="hidden"
    >

    <!--
      @slot Input slot
      @binding {boolean} isChecked - Boolean that defines if input is checked
      @binding {any} value - Value for radio input
      @binding {CSSClasses} classes - The classes for "input" element (see Variantable)
    -->
    <slot
      name="input"
      :is-checked="checked"
      :value="value"
      :classes="getElementCssClass('input')"
    >
      <div
        :data-checked="checked"
        :class="getElementCssClass('input')"
      >
        <v-icon
          v-if="checked"
          name="check"
          scale="0.8"
        />
      </div>
    </slot>

    <!--
      @slot Default slot
      @binding {boolean} isChecked - Boolean that defines if input is checked
      @binding {any} value - Value for radio input
    -->
    <slot
      name="default"
      :is-checked="checked"
      :value="value"
    >
      {{ value }}
    </slot>

  </label>
</template>

<script>
import BaseInput from './BaseInput'
import VModelable from '#mixins/v-modelable/'

/**
 * RadioInput component
 */
export default {
  name: 'RadioInput',
  extends: BaseInput,
  mixins: [
    VModelable
  ],
  // VModelable options
  model: {
    // "sync" with radioValue, not value for radio input
    // ⚠ Now this.radioValue is a prop related to this.vModel, instead of this.value
    prop: 'radioValue'
  },
  props: {
    /**
     * Radio input name
     */
    name: {
      type: String,
      required: true
    },
    /**
     * Radio input value
     */
    value: {
      type: [ String, Object, Number, Boolean, Array ],
      required: true
    }
  },
  computed: {
    /**
     * Returns true if checked
     */
    checked: function () {
      return this.vModel === this.value
    }
  },
  // Variantable options
  style: {
    /* eslint quote-props: ["error", "consistent"] */
    // fixed classes
    fixedClasses: {
      wrapper: {
        'cursor-pointer': true,
        'flex': true,
        'items-center': true,
        'gap-3': true,
        'py-2': true,
        'px-2': true,
        'rounded-full': true
      },
      input: {
        'flex': true,
        'items-center': true,
        'justify-center': true,
        'w-4': true,
        'h-4': true,
        'rounded-full': true
      }
    },
    // Default classes
    classes: {
      wrapper: {
        '@light:if-checked:bg-@light-primary-200': true,
        '@light:bg-@light-white-smoke-100': true,
        '@dark:if-checked:bg-@dark-primary': true,
        '@dark:bg-@dark-mirage': true,
        'shadow-md': true
      },
      input: {
        '@light:if-checked:bg-@light-success': true,
        '@light:bg-@light-white-smoke-600': true,
        '@dark:if-checked:bg-@dark-success': true,
        '@dark:bg-@dark-haiti': true
      }
    },
    variants: {
      /**
       * Common variants
       */
      /**
       * 'light' theme variants
       */
      /**
       * 'dark' theme variants
       */
      haiti: {
        wrapper: {
          'if-checked:bg-@dark-primary': true,
          'hover:bg-@dark-primary': true,
          'bg-@dark-haiti': true,
          'shadow-md': true
        },
        input: {
          'if-checked:bg-@dark-success': true,
          'bg-@dark-black-rock': true
        }
      }
    }
  }
}
</script>

<style lang="scss">
// Do logic
</style>
